Subject: Re: [PATCH bpf-next v7 03/10] bpf: verifier: refactor check_attach_btf_id()

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Tue, 22 Sep 2020 13:16:10 +0200

Andrii Nakryiko <[email-masked]> writes:

> On Sat, Sep 19, 2020 at 4:50 AM Toke Høiland-Jørgensen <[email-masked]> wrote:
>>
>> From: Toke Høiland-Jørgensen <[email-masked]>
>>
>> The check_attach_btf_id() function really does three things:
>>
>> 1. It performs a bunch of checks on the program to ensure that the
>>    attachment is valid.
>>
>> 2. It stores a bunch of state about the attachment being requested in
>>    the verifier environment and struct bpf_prog objects.
>>
>> 3. It allocates a trampoline for the attachment.
>>
>> This patch splits out (1.) and (3.) into separate functions in preparation
>> for reusing them when the actual attachment is happening (in the
>> raw_tracepoint_open syscall operation), which will allow tracing programs
>> to have multiple (compatible) attachments.
>>
>> No functional change is intended with this patch.
>>
>> Acked-by: Andrii Nakryiko <[email-masked]>
>> Signed-off-by: Toke Høiland-Jørgensen <[email-masked]>
>> ---
>
> Ok, so bad news: you broke another selftest (test_overhead). Please,
> do run test_progs and make sure everything succeeds, every time before
> you post a new version.

Right, so I looked into this, and it seems the only reason it was
succeeding before were those skipped checks you pointed out that are now
fixed. I.e., __set_task_comm() is not actually supposed to be
fmod_ret'able according to check_attach_modify_return(). So I'm not sure
what the right way to fix this is?

The fmod_ret bit was added to test_overhead by:

4eaf0b5c5e04 ("selftest/bpf: Fmod_ret prog and implement test_overhead as part of bench")

so the obvious thing is to just do a (partial) revert of that? WDYT?

-Toke